## mingw-w64-osgearth-3.7-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20)

# VCPKG customization ....................................................

if (${CMAKE_TOOLCHAIN_FILE} MATCHES ".*vcpkg.cmake.*")
    message(STATUS "Building with vcpkg toolchain.")
    set(USING_VCPKG ON)
    set(VCPKG_OVERLAY_TRIPLETS ${CMAKE_CURRENT_SOURCE_DIR}/vcpkg/triplets)
endif()


# Project setup ..........................................................

project(
    OSGEARTH
    DESCRIPTION "osgEarth SDK"
    HOMEPAGE_URL "https://github.com/gwaldron/osgearth"
    LANGUAGES CXX C)

# SDK version number
set(OSGEARTH_MAJOR_VERSION 3)
set(OSGEARTH_MINOR_VERSION 7)
set(OSGEARTH_PATCH_VERSION 1)
set(OSGEARTH_VERSION ${OSGEARTH_MAJOR_VERSION}.${OSGEARTH_MINOR_VERSION}.${OSGEARTH_PATCH_VERSION})

# Increment this each time the ABI changes
set(OSGEARTH_SOVERSION 164)

# Require C++14
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Detect out-of-source build. We'll need this for protobuf generated files.
if (NOT "${PROJECT_SOURCE_DIR}" STREQUAL "${PROJECT_BINARY_DIR}")
    message(STATUS "Detected an out-of-source build. Kudos.")    
    set(OSGEARTH_OUT_OF_SOURCE_BUILD TRUE)
else()
    message(STATUS "Detected a in-source build.")  
endif()

# We have some custom .cmake scripts not in the official distribution.
set(CMAKE_MODULE_PATH "${CMAKE_MODULE_PATH};${PROJECT_SOURCE_DIR}/cmake")

# Special folder for build-time generated include files
set(OSGEARTH_BUILDTIME_INCLUDE_DIR "${CMAKE_CURRENT_BINARY_DIR}/build_include")
include_directories(${OSGEARTH_BUILDTIME_INCLUDE_DIR})

# Third-party sources included in the reposotory
set(OSGEARTH_EMBEDDED_THIRD_PARTY_DIR ${PROJECT_SOURCE_DIR}/src/third_party)
    
# Platform-specific settings ............................................

# Default installation folders. The platform-specific includes will
# override these values as necessary.
set(INSTALL_RUNTIME_FOLDER "bin${OSGEARTH_INSTALL_FOLDER_SUFFIX}")  # executables
set(INSTALL_LIBRARY_FOLDER "bin${OSGEARTH_INSTALL_FOLDER_SUFFIX}")  # .dll/.so
set(INSTALL_ARCHIVE_FOLDER "lib${OSGEARTH_INSTALL_FOLDER_SUFFIX}")  # .lib/.a
set(INSTALL_PLUGINS_FOLDER "bin${OSGEARTH_INSTALL_FOLDER_SUFFIX}")  # parent folder of OSG plugins folder

include(oe_ios)
include(oe_osx)
include(oe_unix)
include(oe_win32)

# Build options ..........................................................

option(OSGEARTH_BUILD_TOOLS "Build the osgEarth command-line tools" ON)
option(OSGEARTH_BUILD_EXAMPLES "Build the osgEarth example applications" ON)
option(OSGEARTH_BUILD_IMGUI_NODEKIT "Build the osgEarth ImGui nodekit and ImGui-based apps" ON)
option(OSGEARTH_BUILD_CESIUM_NODEKIT "Build the Cesium nodekit (osgEarthCesium)" OFF)
option(OSGEARTH_BUILD_TRITON_NODEKIT "Build support for SunDog Triton SDK" OFF)
option(OSGEARTH_BUILD_SILVERLINING_NODEKIT "Build support for SunDog SilverLining SDK" OFF)
option(OSGEARTH_ENABLE_GEOCODER "Enable the geocoder (GDAL/OGR must be built with geocoder support)" OFF)

option(OSGEARTH_BUILD_DOCS "Include the documentation folder" ON)
mark_as_advanced(OSGEARTH_BUILD_DOCS)

option(OSGEARTH_BUILD_TESTS "Build the osgEarth unit tests" OFF)
mark_as_advanced(OSGEARTH_BUILD_TESTS)

option(OSGEARTH_BUILD_PROCEDURAL_NODEKIT "Build the procedural terrain nodekit (osgEarthProcedural)" OFF)
mark_as_advanced(OSGEARTH_BUILD_PROCEDURAL_NODEKIT)

option(OSGEARTH_BUILD_LEGACY_SPLAT_NODEKIT "Build the legacy procedural nodekit (osgEarthSplat)" OFF)
mark_as_advanced(OSGEARTH_BUILD_LEGACY_SPLAT_NODEKIT)

option(OSGEARTH_BUILD_LEGACY_CONTROLS_API "Build the legacy Controls UI API" OFF)
mark_as_advanced(OSGEARTH_BUILD_LEGACY_CONTROLS_API)

option(OSGEARTH_BUILD_ZIP_PLUGIN "Build osgEarth's zip plugin based on libzip" ON)
mark_as_advanced(OSGEARTH_BUILD_ZIP_PLUGIN)

option(OSGEARTH_ENABLE_PROFILING "Enable profiling with Tracy" OFF)
mark_as_advanced(OSGEARTH_ENABLE_PROFILING)

option(OSGEARTH_ASSUME_SINGLE_GL_CONTEXT "Assume the use of a single GL context for all GL objects (advanced)" OFF)
mark_as_advanced(OSGEARTH_ASSUME_SINGLE_GL_CONTEXT)

option(OSGEARTH_ASSUME_SINGLE_THREADED_OSG "Assume OSG will always be configured to run in SingleThreaded mode (advanced)" OFF)
mark_as_advanced(OSGEARTH_ASSUME_SINGLE_THREADED_OSG)

option(OSGEARTH_INSTALL_SHADERS "Whether to deploy GLSL shaders when installing (OFF=inlined shaders)" OFF)
mark_as_advanced(OSGEARTH_INSTALL_SHADERS)

if(WIN32)
    option(OSGEARTH_INSTALL_PDBS "Whether to deploy Windows .pdb files" OFF)
endif()

# Dependencies ...........................................................

# Update git submodules
# https://cliutils.gitlab.io/modern-cmake/chapters/projects/submodule.html
find_package(Git QUIET)
if(GIT_FOUND AND EXISTS "${PROJECT_SOURCE_DIR}/.git")
    message(STATUS "Submodule update")
    execute_process(COMMAND ${GIT_EXECUTABLE} submodule update --init --recursive
                    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                    RESULT_VARIABLE GIT_SUBMOD_RESULT)
    if(NOT GIT_SUBMOD_RESULT EQUAL "0")
        message(FATAL_ERROR "git submodule update --init --recursive failed with ${GIT_SUBMOD_RESULT}, please checkout submodules")
    endif()
endif()

# required - globally used
find_package(OpenGL REQUIRED)
find_package(OpenSceneGraph REQUIRED COMPONENTS osgManipulator osgShadow osgSim osgViewer osgGA osgUtil osgText osgDB osg OpenThreads)

# For static builds we need to link with Fontconfig directly.
# There is an unknown issue where the Fc symbols are not found when linking executables statically.
find_package(Fontconfig QUIET)
if (Fontconfig_FOUND)
    list(APPEND OPENSCENEGRAPH_LIBRARIES Fontconfig::Fontconfig)
endif()

# integrated profiling with tracy?
if(OSGEARTH_ENABLE_PROFILING)
    find_package(Tracy)
    if(Tracy_FOUND)
        message(STATUS "Found Tracy. Enabling frame profiling.")
    endif()
endif()

# optimization option:
if(OSGEARTH_ASSUME_SINGLE_GL_CONTEXT)
    add_definitions(-DOSGEARTH_SINGLE_GL_CONTEXT)
endif()

# optimization option:
if(OSGEARTH_ASSUME_SINGLE_THREADED_OSG)
    add_definitions(-DOSGEARTH_SINGLE_THREADED_OSG)
endif()

# Bring in our utility macros that sub-projects will use to configure themselves.
include(cmake/osgearth-macros.cmake)
include(cmake/install-package-config-files.cmake)

# Detect the OSG version so we can append it to plugin DLLs just like OSG does.
detect_osg_version()

if(NOT OPENSCENEGRAPH_VERSION)
	set(OPENSCENEGRAPH_VERSION ${OPENSCENEGRAPH_MAJOR_VERSION}.${OPENSCENEGRAPH_MINOR_VERSION}.${OPENSCENEGRAPH_PATCH_VERSION})
endif()
message(STATUS "Found OSG version ${OPENSCENEGRAPH_VERSION}")

# Make the headers visible to everything
include_directories(
    ${OSGEARTH_SOURCE_DIR}/src
    ${OPENSCENEGRAPH_INCLUDE_DIR})
    
# If OSG is built with OPENGL_PROFILE=GLCORE, <osg/GL> will try to include the GLCORE ARB headers.
# Set this variable to make those headers available when building osgEarth.
set(OSGEARTH_GLCORE_INCLUDE_DIR "" CACHE PATH "Location of OpenGL CORE profile header parent folder")
mark_as_advanced(OSGEARTH_GLCORE_INCLUDE_DIR)
if(OSGEARTH_GLCORE_INCLUDE_DIR)
    include_directories(${OSGEARTH_GLCORE_INCLUDE_DIR})
endif()

# Shared v. static build .................................................

option(OSGEARTH_BUILD_SHARED_LIBS "ON to build shared libraries; OFF to build static libraries." ON)
if(OSGEARTH_BUILD_SHARED_LIBS)
    set(OSGEARTH_DYNAMIC_OR_STATIC "SHARED")
else()
    set(OSGEARTH_DYNAMIC_OR_STATIC "STATIC")
endif()
message(STATUS "Building ${OSGEARTH_DYNAMIC_OR_STATIC} libraries")

# Whether to append SOVERSIONs to libraries (unix)
option(OSGEARTH_SONAMES "ON to append so-version numbers to libraries" ON)


# Source code ............................................................

add_subdirectory(src)

if(OSGEARTH_BUILD_DOCS)
    add_subdirectory(docs)
endif()
    
    
# IDE configuration ......................................................

set_property(GLOBAL PROPERTY USE_FOLDERS ON)
set_property(GLOBAL PROPERTY PREDEFINED_TARGETS_FOLDER "CMake Targets")


# Uninstall target .......................................................

configure_file(
   "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
   "${CMAKE_CURRENT_BINARY_DIR}/uninstall.cmake"
   IMMEDIATE @ONLY
)

add_custom_target(uninstall
   "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/uninstall.cmake"
)

=== docs/CMakeLists.txt ===
### DOCUMENTATION ###

set(DOCS_ROOT
    3.0_upgrade_guide.md
    arcgis.md
    bing.md
    build.md
    cesiumion.md
    composite.md
    conf.py
    contourmap.md
    data.md
    earthfile.md
    elevation.md
    faq.md
    featureimage.md
    featuremodel.md
    gdal.md
    image.md
    index.md
    install.md
    layer.md
    layers.md
    license.md
    mbtiles.md
    osgearth_conv.md
    releasenotes.md
    requirements.txt
    support.md
    tiledfeaturemodel.md
    TileLayer.md
    tms.md
    visiblelayer.md
    wms.md
    xyz.md
)

# prepend directory name
set(temp "")
foreach(f ${DOCS_ROOT})
    list(APPEND temp "source/${f}")
endforeach(f)
set(DOCS_ROOT ${temp})

# todo if we need folders later
# source_group( Developer                    FILES ${DOCS_DEVELOPER} )
# source_group( References\\Drivers          FILES ${DOCS_REFERENCES_DRIVERS} )

add_custom_target(Documentation
    SOURCES
        ${DOCS_ROOT}
)

=== build/linux/Makefile ===
FILES = src/LercLib/BitMask\
	src/LercLib/RLE\
	src/LercLib/BitStuffer2\
	src/LercLib/Huffman\
	src/LercLib/Lerc2\
	src/LercLib/Lerc\
	src/LercLib/Lerc_c_api_impl\
	src/LercLib/Lerc1Decode/BitStuffer\
	src/LercLib/Lerc1Decode/CntZImage

CFLAGS = -Wall -std=c++11 -fPIC -O2 -c
LDFLAGS = -shared -fvisibility=hidden -fvisibility-inlines-hidden

RM = rm -f
INSTALL ?= install
INSTALL_DATA ?= $(INSTALL) -m 644
INSTALL_LIB ?= $(INSTALL) -m 755

DESTDIR     ?=
PREFIX      ?= /usr/local
EXEC_PREFIX ?= $(PREFIX)
LIBDIR      ?= $(EXEC_PREFIX)/lib
INCLUDEDIR  ?= $(PREFIX)/include
LERC2SUFFIX ?= Lerc
LERC1SUFFIX ?= Lerc

SRCS = $(addsuffix .cpp,$(FILES))
OBJS = $(addsuffix .o,  $(FILES))

LIBVER_MAJOR := 2
LIBVER_MINOR := 4
LIBVER_PATCH := 0

SHARED_EXT := so
STATIC_EXT := a
SHARED_EXT_MAJOR := $(SHARED_EXT).$(LIBVER_MAJOR)
SHARED_EXT_VER := $(SHARED_EXT).$(LIBVER_MAJOR).$(LIBVER_MINOR).$(LIBVER_PATCH)
SHARED_LIB = libLerc.$(SHARED_EXT_VER)
STATIC_LIB = libLerc.$(STATIC_EXT)
SONAME_FLAGS = -Wl,-soname=libLerc.$(SHARED_EXT_MAJOR)

.PHONY: all
all: ${TARGET_LIB}

$(SHARED_LIB): $(OBJS)
	$(CXX) ${LDFLAGS} ${SONAME_FLAGS} -o $@ $^

libLerc.a: ARFLAGS = rcs
libLerc.a: $(OBJS)
	@echo compiling static library
	@$(AR) $(ARFLAGS) $@ $^

$(SRCS:.cpp=.o):%.o:%.cpp
	$(CXX) $(CFLAGS) $< -o $@

.PHONY: clean
clean:
	-$(RM) $(SHARED_LIB) $(STATIC_LIB) $(OBJS) 

install: $(SHARED_LIB) $(STATIC_LIB)
	@$(INSTALL) -d -m 755 $(DESTDIR)$(LIBDIR)/
	@$(INSTALL) -d -m 755 $(DESTDIR)$(INCLUDEDIR)/
	@$(INSTALL) -d -m 755 $(DESTDIR)$(INCLUDEDIR)/$(LERC2SUFFIX)
	@$(INSTALL) -d -m 755 $(DESTDIR)$(INCLUDEDIR)/Lerc1Decode/
	@echo Installing libraries
	@$(INSTALL_DATA) $(STATIC_LIB) $(DESTDIR)$(LIBDIR)
	@$(INSTALL_LIB) $(SHARED_LIB) $(DESTDIR)$(LIBDIR)
	@ln -sf $(SHARED_LIB) $(DESTDIR)$(LIBDIR)/libLerc.$(SHARED_EXT_MAJOR)
	@ln -sf $(SHARED_LIB) $(DESTDIR)$(LIBDIR)/libLerc.$(SHARED_EXT)
	@echo Installing includes
	@$(INSTALL_DATA) include/Lerc_c_api.h $(DESTDIR)$(INCLUDEDIR)/$(LERC2SUFFIX)
	@$(INSTALL_DATA) include/Lerc_types.h $(DESTDIR)$(INCLUDEDIR)/$(LERC2SUFFIX)
	@$(INSTALL_DATA) src/LercLib/Lerc.h $(DESTDIR)$(INCLUDEDIR)/$(LERC2SUFFIX)
	@$(INSTALL_DATA) src/LercLib/Lerc2.h $(DESTDIR)$(INCLUDEDIR)/$(LERC2SUFFIX)
	@$(INSTALL_DATA) src/LercLib/Defines.h $(DESTDIR)$(INCLUDEDIR)/$(LERC2SUFFIX)
	@$(INSTALL_DATA) src/LercLib/BitMask.h $(DESTDIR)$(INCLUDEDIR)/$(LERC2SUFFIX)
	@$(INSTALL_DATA) src/LercLib/BitSuffer2.h $(DESTDIR)$(INCLUDEDIR)/$(LERC2SUFFIX)
	@$(INSTALL_DATA) src/LercLib/Huffman.h $(DESTDIR)$(INCLUDEDIR)/$(LERC2SUFFIX)
	@$(INSTALL_DATA) src/LercLib/RLE.h $(DESTDIR)$(INCLUDEDIR)/$(LERC2SUFFIX)
	@$(INSTALL_DATA) src/LercLib/Lerc1Decode/CntZImage.h $(DESTDIR)$(INCLUDEDIR)/$(LERC1SUFFIX)/
	@$(INSTALL_DATA) src/LercLib/Lerc1Decode/TImage.hpp $(DESTDIR)$(INCLUDEDIR)/$(LERC1SUFFIX)/
	@$(INSTALL_DATA) src/LercLib/Lerc1Decode/Image.h $(DESTDIR)$(INCLUDEDIR)/$(LERC1SUFFIX)/
	@echo static and shared library installed

uninstall:
	@$(RM) $(DESTDIR)$(LIBDIR)/$(STATIC_LIB)
	@$(RM) $(DESTDIR)$(LIBDIR)/libLerc.$(SHARED_EXT)
	@$(RM) $(DESTDIR)$(LIBDIR)/libLerc.$(SHARED_EXT_MAJOR)
	@$(RM) $(DESTDIR)$(LIBDIR)/libLerc.$(SHARED_EXT_VER)
	@$(RM) $(DESTIDR)$(INCLUDEIDR)/Lerc_c_api.h
	@$(RM) $(DESTIDR)$(INCLUDEIDR)/Lerc_types.h
	@$(RM) $(DESTIDR)$(INCLUDEIDR)/$(LERC2SUFFIX)/Lerc2.h
	@$(RM) $(DESTIDR)$(INCLUDEIDR)/$(LERC2SUFFIX)/Defines.h
	@$(RM) $(DESTIDR)$(INCLUDEIDR)/$(LERC2SUFFIX)/BitMasC.h
	@$(RM) $(DESTIDR)$(INCLUDEIDR)/$(LERC2SUFFIX)/BitSuffer2.h
	@$(RM) $(DESTIDR)$(INCLUDEIDR)/$(LERC2SUFFIX)/Huffman.h
	@$(RM) $(DESTIDR)$(INCLUDEIDR)/$(LERC2SUFFIX)/RLE.h
	@$(RM) $(DESTIDR)$(INCLUDEIDR)/$(LERC1SUFFIX)/GntZImage.h
	@$(RM) $(DESTIDR)$(INCLUDEIDR)/$(LERC1SUFFIX)/TImage.hpp
	@$(RM) $(DESTIDR)$(INCLUDEIDR)/$(LERC1SUFFIX)/Image.h

=== share/ExternalProject/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.20)

project(ExternalExample)

find_package(osgEarth CONFIG REQUIRED)

add_executable(ExternalExample main.cpp)

target_link_libraries(ExternalExample PRIVATE osgEarth::osgEarth)

=== src/applications/CMakeLists.txt ===
if(NOT OSGEARTH_BUILD_PLATFORM_IPHONE)

    if(NOT OSGEARTH_BUILD_SHARED_LIBS)
        add_definitions(-DOSGEARTH_LIBRARY_STATIC)
    endif()

    # Tools:
    if(OSGEARTH_BUILD_TOOLS)
        set(TARGET_DEFAULT_LABEL_PREFIX "Tool")
        set(TARGET_DEFAULT_APPLICATION_FOLDER "Tools")
        add_subdirectory(osgearth_viewer)
        add_subdirectory(osgearth_imgui)
        add_subdirectory(osgearth_tfs)
        add_subdirectory(osgearth_boundarygen)
        add_subdirectory(osgearth_version)
        add_subdirectory(osgearth_atlas)
        add_subdirectory(osgearth_bakefeaturetiles)
        add_subdirectory(osgearth_conv)
        add_subdirectory(osgearth_3pv)
        add_subdirectory(osgearth_clamp)
        
        if(OSGEARTH_BUILD_PROCEDURAL_NODEKIT)
            add_subdirectory(osgearth_exportvegetation)
            add_subdirectory(osgearth_biome)
            add_subdirectory(osgearth_imposterbaker)
        endif()

        IF (Protobuf_FOUND AND SQLITE3_FOUND)
            add_subdirectory(osgearth_mvtindex)
        ENDIF()   
        
        if(OSGEARTH_BUILD_LEGACY_CONTROLS_API)
            add_subdirectory(osgearth_createtile)
        endif()
        
        if(OSGEARTH_BUILD_LEGACY_SPLAT_NODEKIT)
            add_subdirectory(osgearth_exportgroundcover_splat)
        endif()     

        if (OSGEARTH_HAVE_MESH_OPTIMIZER)
            add_subdirectory(osgearth_lod)
        endif()
    ENDIF()

    # Examples:
    if(OSGEARTH_BUILD_EXAMPLES)
        set(TARGET_DEFAULT_LABEL_PREFIX "Example")
        set(TARGET_DEFAULT_APPLICATION_FOLDER "Examples")
        add_subdirectory(osgearth_simple)
        add_subdirectory(osgearth_features)
        add_subdirectory(osgearth_featurefilter)
        add_subdirectory(osgearth_los)
        add_subdirectory(osgearth_terrainprofile)
        add_subdirectory(osgearth_map)
        add_subdirectory(osgearth_annotation)
        add_subdirectory(osgearth_occlusionculling)
        add_subdirectory(osgearth_minimap)
        add_subdirectory(osgearth_mrt)
        add_subdirectory(osgearth_skyview)
        add_subdirectory(osgearth_infinitescroll)
        add_subdirectory(osgearth_video)
        add_subdirectory(osgearth_heatmap)
        
        if(OSGEARTH_BUILD_LEGACY_CONTROLS_API)
            add_subdirectory(osgearth_cluster)
            add_subdirectory(osgearth_eci)
            add_subdirectory(osgearth_ephemeris)
            add_subdirectory(osgearth_graticule)
            add_subdirectory(osgearth_magnify)
            add_subdirectory(osgearth_manip)
            add_subdirectory(osgearth_tracks)
            add_subdirectory(osgearth_transform)
        endif()
    endif()
    
    if(OSGEARTH_BUILD_TESTS)
        set(TARGET_DEFAULT_LABEL_PREFIX "Test")
        set(TARGET_DEFAULT_APPLICATION_FOLDER "Tests")
        add_subdirectory(osgearth_bindless)
        add_subdirectory(osgearth_collecttriangles)
        add_subdirectory(osgearth_drawables)
        add_subdirectory(osgearth_horizon)
        add_subdirectory(osgearth_lights)
        add_subdirectory(osgearth_overlayviewer)
        add_subdirectory(osgearth_windows)
        
        if(OSGEARTH_BUILD_LEGACY_CONTROLS_API)
            add_subdirectory(osgearth_shadercomp)
            
            if(OSGEARTH_HAVE_SILVERLINING_NODEKIT)
                add_subdirectory(osgearth_silverlining)
            endif()

            if(OSGEARTH_HAVE_TRITON_NODEKIT)
                add_subdirectory(osgearth_triton)
            endif()
        endif()
    endif()

else()

    # ios
    IF(OSGEARTH_BUILD_EXAMPLES)
        SET(TARGET_DEFAULT_LABEL_PREFIX "Example")
        SET(TARGET_DEFAULT_APPLICATION_FOLDER "Examples")
        add_subdirectory(osgearth_viewerIOS)
    endif()

endif()

=== src/osgEarthDrivers/CMakeLists.txt ===
#include_directories(${OSG_INCLUDE_DIRS})

#set(CMAKE_SHARED_MODULE_PREFIX ${OSGEARTH_PLUGIN_PREFIX})

#OpenThreads, osg, osgDB and osgUtil are included elsewhere.
#SET(TARGET_COMMON_LIBRARIES
#    osgEarth
#)

if(BASISU_FOUND)
    add_subdirectory(basis)
endif()
add_subdirectory(bumpmap)
add_subdirectory(cache_filesystem)
add_subdirectory(colorramp)
add_subdirectory(detail)
#add_subdirectory(draco)
add_subdirectory(earth)
add_subdirectory(engine_rex)
add_subdirectory(featurefilter_intersect)
add_subdirectory(featurefilter_join)
add_subdirectory(gltf)
add_subdirectory(kml)
add_subdirectory(script_engine_duktape)
add_subdirectory(sky_gl)
add_subdirectory(sky_simple)
add_subdirectory(template)
add_subdirectory(terrainshader)
add_subdirectory(vdatum_egm2008)
add_subdirectory(vdatum_egm84)
add_subdirectory(vdatum_egm96)
add_subdirectory(viewpoints)
add_subdirectory(webp)
add_subdirectory(zip)

if(OSGEARTH_HAVE_SILVERLINING_NODEKIT)
    add_subdirectory(sky_silverlining)
endif()

# if(OSGEARTH_BUILD_LEVELDB_CACHE)
    # add_subdirectory(cache_leveldb)
# endif()

add_subdirectory(cache_rocksdb)

IF(NOT APPLE AND NOT ANDROID)
    add_subdirectory(fastdxt)
    add_subdirectory(lerc)
ENDIF()

=== src/tests/CMakeLists.txt ===
PROJECT(OSGEARTH_TESTS)

SET(OSGCORE_BUNDLED TRUE)

IF(NOT OSGCORE_BUNDLED)
	FIND_PACKAGE(OSGCORE)
	IF(OSGCORE_FOUND)
		INCLUDE(${OSGCORE_USE_FILE})
	ELSE(OSGCORE_FOUND)
		MESSAGE(ERROR "OSGCORE needed but NOT FOUND")
	ENDIF(OSGCORE_FOUND)
	SET(CMAKE_MODULE_PATH  ${PROJECT_SOURCE_DIR}/../../Macros)
ENDIF(NOT OSGCORE_BUNDLED)
SET(OPENSCENEGRAPH_APPLICATION_DIR ${PROJECT_SOURCE_DIR})


#OpenThreads, osg, osgDB and osgUtil are included elsewhere.
SET(TARGET_COMMON_LIBRARIES
    osgEarth
)

SET(TARGET_DEFAULT_PREFIX "test_")
SET(TARGET_DEFAULT_APPLICATION_FOLDER "Tests")


enable_testing()
ADD_SUBDIRECTORY(osgEarth_tests)

=== src/applications/osgearth_bakefeaturetiles/CMakeLists.txt ===
add_osgearth_app(
    TARGET osgearth_bakefeaturetiles
    SOURCES osgearth_bakefeaturetiles.cpp
    FOLDER Tools)

=== src/applications/osgearth_city/CMakeLists.txt ===
add_osgearth_app(
    TARGET osgearth_city
    SOURCES osgearth_city.cpp
    FOLDER Examples )

=== src/applications/osgearth_conv/CMakeLists.txt ===
add_osgearth_app(
    TARGET osgearth_conv
    SOURCES osgearth_conv.cpp
    FOLDER Tools )

=== src/applications/osgearth_exportgroundcover_splat/CMakeLists.txt ===
add_osgearth_app(
    TARGET osgearth_exportgroundcover_splat
    SOURCES osgearth_exportgroundcover.cpp
    LIBRARIES osgEarthSplat
    FOLDER Tools)

=== src/applications/osgearth_exportvegetation/CMakeLists.txt ===
add_osgearth_app(
    TARGET osgearth_exportvegetation
    SOURCES osgearth_exportvegetation.cpp
    LIBRARIES osgEarthProcedural
    FOLDER Tools)

=== PKGBUILD ===
# Maintainer: James Duley <jagduley gmail>
# Maintainer: Philippe Renon <philippe_renon yahoo.fr>

_realname=osgearth
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=3.7
pkgrel=1
_rj_ver=1.1.0
_lerc_commit=19542a00b9a8b5c1089f74239e5859e02e403212
arch=('any')
pkgdesc="A terrain rendering toolkit for OpenSceneGraph (mingw-w64)"
mingw_arch=('ucrt64' 'clang64')
url="https://www.pelicanmapping.com/home-1/opensource"
msys2_repository_url="https://github.com/gwaldron/osgearth"
msys2_references=(
  'aur: osgearth'
)
license=('spdx:LGPL-3.0-or-later WITH LGPL-3.0-linking-exception')
depends=("${MINGW_PACKAGE_PREFIX}-curl"
         #"${MINGW_PACKAGE_PREFIX}-blosc"
         #"${MINGW_PACKAGE_PREFIX}-draco"
         "${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-gdal"
         "${MINGW_PACKAGE_PREFIX}-geos"
         "${MINGW_PACKAGE_PREFIX}-glew"
         #"${MINGW_PACKAGE_PREFIX}-leveldb"
         #"${MINGW_PACKAGE_PREFIX}-libzip"
         "${MINGW_PACKAGE_PREFIX}-OpenSceneGraph"
         "${MINGW_PACKAGE_PREFIX}-protobuf"
         "${MINGW_PACKAGE_PREFIX}-spdlog"
         "${MINGW_PACKAGE_PREFIX}-sqlite3")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-pkgconf"
             "${MINGW_PACKAGE_PREFIX}-libwebp"
             "${MINGW_PACKAGE_PREFIX}-rocksdb")
optdepends=("${MINGW_PACKAGE_PREFIX}-libwebp"
            "${MINGW_PACKAGE_PREFIX}-rocksdb")
source=("https://github.com/gwaldron/osgearth/archive/${_realname}-${pkgver}.tar.gz"
        "https://github.com/Tencent/rapidjson/archive/v${_rj_ver}/rapidjson-v${_rj_ver}.tar.gz"
        "https://github.com/Esri/lerc/archive/${_lerc_commit}/lerc-${_lerc_commit}.tar.gz"
        "0001-fix-cmake-config-install-destination.patch"
        "0002-cxx-standard-17.patch"
        "0101-rj-remove-non-compiling-assignment-operator.patch::https://patch-diff.githubusercontent.com/raw/Tencent/rapidjson/pull/719.patch")
sha256sums=('d13d0f749759f8f012eb1fb7cd29ae30b73fc4463b817c8c31f0ac408cfadd16'
            'bf7ced29704a1e696fbccf2a2b4ea068e7774fa37f6d7dd4039d0787f8bed98e'
            '11988ad44f4b63df7dde62bccde9b194cff468bf389912e3f3f7ebf06246c370'
            '21becfcea4f11f055f0b94eccc8a0e7e6fde7c8cca85951835bffbea2681b431'
            'ae80d6a24c6115a893373df572a0c47c7aedfe3913ffe2d247d510b9abc73f78'
            '8abc5c5ef033801ea99a9f289126e473ccf4ebdb9ab33fa8157f957fdeb03a2f')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd "${srcdir}"/rapidjson-${_rj_ver}
  apply_patch_with_msg \
    0101-rj-remove-non-compiling-assignment-operator.patch
  
  cd "${srcdir}"/${_realname}-${_realname}-${pkgver}
  apply_patch_with_msg \
    0001-fix-cmake-config-install-destination.patch \
    0002-cxx-standard-17.patch

  mv "${srcdir}"/rapidjson-${_rj_ver}/* src/third_party/rapidjson/
  mv "${srcdir}"/lerc-${_lerc_commit}/* src/third_party/lerc/
}

build() {
  mkdir -p "${srcdir}"/build-${MSYSTEM} && cd "${srcdir}"/build-${MSYSTEM}

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  CXXFLAGS+=" -w -Wno-register" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  "${MINGW_PREFIX}"/bin/cmake.exe \
    -GNinja \
    -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
    "${_extra_config[@]}" \
    -DOSG_DIR="${MINGW_PREFIX}" \
    -DOSGEARTH_BUILD_EXAMPLES=OFF \
    -DOSGEARTH_BUILD_TESTS=OFF \
    -DOSGEARTH_BUILD_LEGACY_SPLAT_NODEKIT=ON \
    -DOSGEARTH_BUILD_ZIP_PLUGIN=OFF \
    -DOSGEARTH_PROTOBUF_FORCE_CONFIG_MODE=ON \
    -DCURL_NO_CURL_CMAKE=ON \
    -DMY_LIBRARIES="dbghelp" \
    ../${_realname}-${_realname}-${pkgver}

  "${MINGW_PREFIX}"/bin/cmake.exe --build .
}

package() {
  cd build-${MSYSTEM}
  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install .

  mkdir -p "${pkgdir}${MINGW_PREFIX}"/share/osgearth
  cp -rf "${srcdir}"/${_realname}-${_realname}-${pkgver}/data \
    "${pkgdir}${MINGW_PREFIX}"/share/osgearth

  local PREFIX_WIN=$(cygpath -wm ${MINGW_PREFIX})
  for _f in "${pkgdir}${MINGW_PREFIX}"/lib/cmake/osgearth/*.cmake; do
    sed -e "s|${PREFIX_WIN}|\$\{_IMPORT_PREFIX\}|g" -i ${_f}
    sed -e "s|${MINGW_PREFIX}|\$\{_IMPORT_PREFIX\}|g" -i ${_f}
  done

  install -Dm644 "${srcdir}"/${_realname}-${_realname}-${pkgver}/LICENSE.txt \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE
}

=== build/linux/debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

ifeq ($(origin CC),default)
	CXX := $(DEB_HOST_GNU_TYPE)-g++
endif

%:
	dh $@ 

override_dh_install:
	$(MAKE) -f build/linux/Makefile install PREFIX=/usr DESTDIR=$$(pwd)/debian/tmp CXX=$(CXX)
	d-shlibmove --commit --multiarch --shlibs-local --exclude-la \
				--movedev "debian/tmp/usr/include/*" usr/include \
				debian/tmp/usr/lib/lib*.so

override_dh_auto_build:
	$(MAKE) -f debian/Makefile
